package cat.altcamp.altcapp;


import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.app.ListFragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.parse.FindCallback;
import com.parse.GetDataCallback;
import com.parse.ParseException;
import com.parse.ParseFile;
import com.parse.ParseObject;
import com.parse.ParseQuery;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;
import java.util.Arrays;
import java.util.List;


public class rutes extends ListFragment{


    private static String[][] fila = new String[60][60];
    private static int a=0;
    private static ParseFile[][] imatges = new ParseFile[60][2];

    public static rutes newInstance(Bundle arguments) {
        rutes f = new rutes();
        if(arguments != null){

            f.setArguments(arguments);
        }
        return f;
    }

    public rutes(){

    }


    public void inici_mapa(FragmentActivity act, String [][] dades, ParseFile[][] img,  int position, Context c) {

        ParseFile f;
        final ProgressDialog DialogCargando = new ProgressDialog(act);


        try {

        DialogCargando.setMessage("Descarregant track... Esperi, si us plau. ");
            DialogCargando.show();

            f=img[position][1];

            File SDCardRoot = Environment.getExternalStorageDirectory();
            File file = new File(SDCardRoot,f.getName());
           FileOutputStream fileOutput = new FileOutputStream(file);


            byte[] buffer = f.getData();
            int bufferLength = buffer.length; //used to store a temporary size of the buffer

            fileOutput.write(buffer, 0, bufferLength);
            fileOutput.close();

            DialogCargando.dismiss();

            Toast.makeText(act, "El track s'ha desat correctament!",
                    Toast.LENGTH_LONG).show();


        }catch (NullPointerException  ex ){
            Toast.makeText(act, "No existeix cap track per aquesta ruta!",
                    Toast.LENGTH_LONG).show();
            DialogCargando.dismiss();

        }  catch (IOException e) {
            Toast.makeText(act, "Error en la creació del fitxer!",
                    Toast.LENGTH_LONG).show();
            DialogCargando.dismiss();
        } catch (ParseException e) {
            Toast.makeText(act, "Error en la creació del fitxer!",
                    Toast.LENGTH_LONG).show();
            DialogCargando.dismiss();
        }


    }

    public void inici_fragment_detall(FragmentActivity act, String [][] dades, int position, String tipus) {


        Fragment fragmentCUATRO = new detall_ruta();

        Bundle args = new Bundle();
        args.putString("nom", dades[position][0]);
        fragmentCUATRO.setArguments(args);

        FragmentManager fm = act.getSupportFragmentManager();
        FragmentTransaction transaction = fm.beginTransaction();


        Log.e("Dentro del done", "" +transaction);

        transaction.replace(R.id.container, fragmentCUATRO);
        transaction.addToBackStack(null);

        transaction.commit();

    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        Bundle bundle = getArguments();

        final String tipus = bundle.getString("tipus");

        final ProgressDialog DialogCargando = new ProgressDialog(getActivity());

        DialogCargando.setMessage("Carregant "+ tipus +"... Esperi, si us plau. ");
        DialogCargando.show();

        ParseQuery<ParseObject> query2 = ParseQuery.getQuery("rutes");
        query2.orderByDescending("nom");
        query2.whereEqualTo("tipus_ruta", tipus);

        query2.findInBackground(new FindCallback<ParseObject>() {
            public void done(List<ParseObject> ofertas, ParseException e) {

                DialogCargando.dismiss();

                if (e == null) {
                    if (ofertas.size() > 0) {
                        a = 0;
                        String dada;
                        for (int i = 0; i < ofertas.size(); i++) {

                           try{
                             fila[i][0] = ofertas.get(i).get("nom").toString();
                           }catch (NullPointerException  ex ){
                                fila[i][0] ="nom no disponible";
                           }
                           try{
                                fila[i][1] = ofertas.get(i).get("municipi").toString();
                            }catch (NullPointerException  ex ){
                                fila[i][1] ="tlf no disponible";
                            }
                            try{
                                fila[i][2] = ofertas.get(i).get("descripció").toString();
                            }catch (NullPointerException  ex ){
                                fila[i][2] ="0";
                            }
                             try{
                                fila[i][3] = ofertas.get(i).get("distancia").toString();
                            }catch (NullPointerException  ex ){
                                fila[i][3] ="no hi ha track disponible!";
                            }

                            try{
                               imatges[i][0] = ofertas.get(i).getParseFile("imatge");
                            }catch (NullPointerException  ex ){

                            }
                            try{
                                imatges[i][1] = ofertas.get(i).getParseFile("ruta");
                            }catch (NullPointerException  ex ){

                            }
                            a++;

                         }

                        String[][]  b = Arrays.copyOf(fila, a);
                        ParseFile[][] c =Arrays.copyOf(imatges,a);


                        setListAdapter(new adaptador_rutes(getActivity(), b, c, getActivity(), tipus));


                    } else {
                        Toast.makeText(getActivity(), "Aquesta categoria no disposa de rutes actualment!",
                                Toast.LENGTH_LONG).show();
                    }

                } else {
                    DialogCargando.dismiss();
                    Toast.makeText(getActivity(), "Error en la connexió a la base de dades!",
                            Toast.LENGTH_LONG).show();
                }
            }

        });
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.allotjaments, container, false);

        Bundle bundle = getArguments();

        String tipus = bundle.getString("tipus");

        TextView texto = (TextView) view.findViewById(R.id.texto);
        texto.setText(tipus);

        return view;
    }



    public void Inicio (View view){

    }

    public void Ofertas (View view){

    }





}
